# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

Public Member Functions | Protected Attributes

# vl::StencilFunc Class Reference

Wraps the OpenGL functions glStencilFunc() and glStencilFuncSeparate(), see also http://www.opengl.org/sdk/docs/man/xhtml/glStencilFunc.xml and http://www.opengl.org/sdk/docs/man/xhtml/glStencilFuncSeparate.xml for more information. More...

`#include <Shader.hpp>`

Inheritance diagram for vl::StencilFunc:

List of all members.

## Public Member Functions

| StencilFunc (EFunction function=FU_ALWAYS, int refvalue=0, unsigned int mask=~(unsigned int) 0)
virtual ERenderState | type () const
virtual void | apply (int index, const Camera *, OpenGLContext *ctx) const
| The parameter cameara is NULL if we are disabling the state, non-NULL if we are enabling it.
void | set (EPolygonFace face, EFunction function, int refvalue, unsigned int mask)
EFunction | function_Front () const
int | refValue_Front () const
unsigned int | mask_Front () const
EFunction | function_Back () const
int | refValue_Back () const
unsigned int | mask_Back () const
virtual ref< RenderState > | clone () const

## Protected Attributes

EFunction | mFunction_Front
EFunction | mFunction_Back
int | mRefValue_Front
int | mRefValue_Back
unsigned int | mMask_Front
unsigned int | mMask_Back

## Detailed Description

Wraps the OpenGL functions glStencilFunc() and glStencilFuncSeparate(), see also http://www.opengl.org/sdk/docs/man/xhtml/glStencilFunc.xml and http://www.opengl.org/sdk/docs/man/xhtml/glStencilFuncSeparate.xml for more information.

See also:
  Shader, Effect, Actor, StencilMask, StencilOp, vl::EN_STENCIL_TEST

Definition at line 1279 of file Shader.hpp.

## Constructor & Destructor Documentation

vl::StencilFunc::StencilFunc | ( | EFunction | function = `FU_ALWAYS`,
|  | int | refvalue = `0`,
|  | unsigned int | mask = `~(unsigned int)0`
| ) |  | `[inline]`

Definition at line 1284 of file Shader.hpp.

References VL_DEBUG_SET_OBJECT_NAME.

## Member Function Documentation

virtual ERenderState vl::StencilFunc::type | ( | ) | const`[inline, virtual]`

Reimplemented from vl::RenderState.

Definition at line 1292 of file Shader.hpp.

References vl::RS_StencilFunc.

void StencilFunc::apply | ( | int | index,
|  | const Camera * | camera,
|  | OpenGLContext * | ctx
| ) |  | const`[virtual]`

The parameter cameara is NULL if we are disabling the state, non-NULL if we are enabling it.

Implements vl::RenderState.

Definition at line 639 of file Shader.cpp.

References vl::Has_GL_Version_2_0, mFunction_Back, mFunction_Front, mMask_Back, mMask_Front, mRefValue_Back, mRefValue_Front, and VL_CHECK_OGL.

void vl::StencilFunc::set | ( | EPolygonFace | face,
|  | EFunction | function,
|  | int | refvalue,
|  | unsigned int | mask
| ) |  | `[inline]`

Definition at line 1296 of file Shader.hpp.

References vl::PF_BACK, vl::PF_FRONT, and vl::PF_FRONT_AND_BACK.

EFunction vl::StencilFunc::function_Front | ( | ) | const`[inline]`

Definition at line 1312 of file Shader.hpp.

int vl::StencilFunc::refValue_Front | ( | ) | const`[inline]`

Definition at line 1314 of file Shader.hpp.

unsigned int vl::StencilFunc::mask_Front | ( | ) | const`[inline]`

Definition at line 1316 of file Shader.hpp.

EFunction vl::StencilFunc::function_Back | ( | ) | const`[inline]`

Definition at line 1318 of file Shader.hpp.

int vl::StencilFunc::refValue_Back | ( | ) | const`[inline]`

Definition at line 1320 of file Shader.hpp.

unsigned int vl::StencilFunc::mask_Back | ( | ) | const`[inline]`

Definition at line 1322 of file Shader.hpp.

virtual ref<RenderState> vl::StencilFunc::clone | ( | ) | const`[inline, virtual]`

Implements vl::RenderState.

Definition at line 1324 of file Shader.hpp.

## Member Data Documentation

EFunction vl::StencilFunc::mFunction_Front`[protected]`

Definition at line 1332 of file Shader.hpp.

Referenced by apply().

EFunction vl::StencilFunc::mFunction_Back`[protected]`

Definition at line 1333 of file Shader.hpp.

Referenced by apply().

int vl::StencilFunc::mRefValue_Front`[protected]`

Definition at line 1334 of file Shader.hpp.

Referenced by apply().

int vl::StencilFunc::mRefValue_Back`[protected]`

Definition at line 1335 of file Shader.hpp.

Referenced by apply().

unsigned int vl::StencilFunc::mMask_Front`[protected]`

Definition at line 1336 of file Shader.hpp.

Referenced by apply().

unsigned int vl::StencilFunc::mMask_Back`[protected]`

Definition at line 1337 of file Shader.hpp.

Referenced by apply().

The documentation for this class was generated from the following files:

- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/Shader.hpp
- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/Shader.cpp

Visualization Library v2011.09.1162 Reference Documentation
Copyright 2005-2011 Michele Bosi. All rights reserved.
Updated on Thu Jan 26 2012 00:44:52.
Permission is granted to use this page to write and publish articles regarding Visualization Library.